Subject: Re: Sharing nested subparts of large repository?

From: Neal Kreitzinger <[email-masked]>
Date: Wed, 28 Mar 2012 04:52:21 -0500

On 3/25/2012 11:38 AM, LordSmoke wrote:
> I've been using git for a couple of months to get used to the system.
> Basic stuff - a few larger project repositories in unique
> directories, commits, pushes to a remote repository. Mostly as a kind
> of backup system.
>
> However, my ultimate goal is to share part of one large project
> currently being managed with git with my developers. I want them to
> have access to source code and test data, but not my manuscripts,
> correspondence, whatever.
>
> I also want to make a portion of what I will give my developers
> available as open source, e.g., on github, but not all of it. Just
> the stable, non-developmental parts. NOT the our development stuff
> and not the parts being used for private contracts.
>
> Submodules seem promising, but the examples are not quite what I am
> looking for, as far as I can tell. They talk about isolating
> submodules that depend on a larger project. I want to make available
> the larger project while keeping nested submodules (so to speak)
> private.
>
It sounds like maybe your superproject has all the submodules and their
superproject has only some of the submodules.  You can also have a 
superproject just like theirs so you have a superproject with everything 
(because your special) and another superproject like theirs (so you can 
pretend to be just like them).

I'm not a submodule expert, but I'm pretty sure you can do that. 
Whether or not that matches up with your current structure of various 
git repos or not I don't know (enough details).

v/r,
neal